importPath=string.gsub(getfenv(1)._.Name,"%.Main","").."."
resourcePath=string.gsub(importPath,"%.","/").."Resources/"
pluginName=plugin:GetName();
-- to do
-- rewrite with text as main window.
-- make animated compass and needle just simple windows with backgrounds, no controls



-- foreign language support, need french and german translations of String.lua


import (importPath.."Class");
import (importPath.."VindarPatch");
-- This is the Load/Save patch which accounts for European formats, written by Vindar
-- load resource strings - this MUST occur before any windows that use strings get loaded or there will be no defaults
import (importPath.."Strings");
import (importPath.."Table");
import "Turbine";
import "Turbine.Gameplay";
import "Turbine.UI";
import "Turbine.UI.Lotro";
displayWidth=Turbine.UI.Display:GetWidth()
displayHeight=Turbine.UI.Display:GetHeight()
compassHeight=64
heading=0
animatingInterval=.01
animatingState=0
animatingStep=0
nextAnimatingTime=0
movingToggle=false
if (tonumber("1,000")==1) then
	function euroNormalize(value)
		return tonumber((string.gsub(value,"%.",",")));
	end
else
	function euroNormalize(value)
		return tonumber((string.gsub(value,",",".")));
	end
end

function AddCallback(object, event, callback)
    if (object[event] == nil) then
        object[event] = callback;
    else
        if (type(object[event]) == "table") then
            table.insert(object[event], callback);
        else
            object[event] = {object[event], callback};
        end
    end
    return callback;
end
function RemoveCallback(object, event, callback)
    if (object[event] == callback) then
        object[event] = nil;
    else
        if (type(object[event]) == "table") then
            local size = table.getn(object[event]);
            for i = 1, size do
                if (object[event][i] == callback) then
                    table.remove(object[event], i);
                    break;
                end
            end
        end
    end
end
mainVisible=true;
hudVisible=true; -- assume hud is visible when loading plugins -- I hate this assumption, but Turbine has failed to provide a legitimate means of testing the hud state
language=1;
locale=Turbine.Engine:GetLanguage()

localPlayer=Turbine.Gameplay.LocalPlayer.GetInstance();

string.split=function(str,separator)
	local tmpArray={};
	local tmpElem;
	str=tostring(str);
	if string.find("^$()%.[]*+-?",separator,1,true)~=nil then separator="%"..separator end
	for tmpElem in string.gmatch(str,"[^"..separator.."]*") do
		table.insert(tmpArray,tmpElem);
	end
	local tmpIndex=1;
	while tmpIndex<=#tmpArray do
		if tmpIndex==#tmpArray and tmpArray[tmpIndex]=="" then
			table.remove(tmpArray,tmpIndex);
		else
			if tmpArray[tmpIndex]=="" and tmpArray[tmpIndex+1]~="" then
				table.remove(tmpArray,tmpIndex);
			else
				tmpIndex=tmpIndex+1;
			end
		end
	end
	return tmpArray;
end
string.ltrim=function(str)
	return (string.gsub(str, "^%s*(.-)", "%1"))
end
string.rtrim=function(str)
	return (string.gsub(str, "^(.-)%s*$", "%1"))
end
string.trim=function(str)
	return (string.gsub(str, "^%s*(.-)%s*$", "%1"))
end

-- load saved settings
Settings=PatchDataLoad(Turbine.DataScope.Character, pluginName.."Settings")
if Settings==nil then Settings={} end

-- load the settings and set the window position if possible, otherwise default to center
local initHeight=20;
local initWidth=compassHeight;
if initWidth>displayWidth then initWidth=displayWidth end
if initHeight>displayHeight then initHeight=displayHeight end
local initLeft=(displayWidth - initWidth) / 2;
local initTop=(displayHeight - initHeight) / 2;

if Settings.Top~=nil then
	Settings.Top=euroNormalize(Settings.Top)
	initTop=displayHeight*Settings.Top
else
	Settings.Top=.5
end
initTop=displayHeight*Settings.Top
if Settings.Left~=nil then
	Settings.Left=euroNormalize(Settings.Left)
else
	Settings.Left=.5
end
initLeft=displayWidth*Settings.Left
if Settings.Width~=nil then
	Settings.Width=euroNormalize(Settings.Width)
else
	Settings.Width=compassHeight/displayWidth
end
initWidth=displayWidth*Settings.Width
if Settings.Height~=nil then
	Settings.Height=euroNormalize(Settings.Height)
else
	Settings.Height=compassHeight/displayHeight
end
initHeight=displayHeight*Settings.Height
if Settings.Opacity~=nil then
	Settings.Opacity=euroNormalize(Settings.Opacity)
else
	Settings.Opacity=1
end
if Settings.Animate==nil then
	Settings.Animate=true
end
if Settings.TrimColor==nil then
	Settings.TrimColor=Turbine.UI.Color(.2,.5,.9)
else
	Settings.TrimColor=Turbine.UI.Color(euroNormalize(Settings.TrimColor.A),euroNormalize(Settings.TrimColor.R),euroNormalize(Settings.TrimColor.G),euroNormalize(Settings.TrimColor.B))
end
if Settings.FontColor==nil then
	Settings.FontColor=Turbine.UI.Color(1,.9,.5)
else
	Settings.FontColor=Turbine.UI.Color(euroNormalize(Settings.FontColor.A),euroNormalize(Settings.FontColor.R),euroNormalize(Settings.FontColor.G),euroNormalize(Settings.FontColor.B))
end
if Settings.BackColor==nil then
	Settings.BackColor=Turbine.UI.Color(.05,.05,.05);
else
	Settings.BackColor=Turbine.UI.Color(euroNormalize(Settings.BackColor.A),euroNormalize(Settings.BackColor.R),euroNormalize(Settings.BackColor.G),euroNormalize(Settings.BackColor.B))
end
if Settings.FontFace==nil then
	Settings.FontFace=Turbine.UI.Lotro.Font.TrajanPro14;
end
if Settings.Language==nil then
	Settings.Language=language
else
	language=Settings.Language
end
if Settings.DataVersion==nil then
	Settings.DataVersion=plugin:GetVersion()
end

-- now import
import (importPath.."DropDownList");
import (importPath.."RadioButtonGroup");
import (importPath.."FontSupport")
import (importPath.."DebugWindow");
import (importPath.."OptionsWindow");

initHeight=Turbine.UI.Lotro.FontInfo[Settings.FontFace].size+2
-- account for changed resolution
if initLeft>(Turbine.UI.Display.GetWidth()-initWidth) then initLeft=Turbine.UI.Display.GetWidth()-initWidth end;
if initLeft<0 then initLeft=0 end;
if initTop>(Turbine.UI.Display.GetHeight()-initHeight) then initTop=Turbine.UI.Display.GetHeight()-initHeight end;
if initTop<0 then initTop=0 end;

moveWindow=Turbine.UI.Window()
moveWindow:SetOpacity(1);
moveWindow:SetPosition(initLeft,initTop-19)
moveWindow.MovePanel=Turbine.UI.Control();
moveWindow.MovePanel:SetParent(moveWindow);
moveWindow.MovePanel:SetSize(173,19);
moveWindow.MovePanel:SetBackColor(Turbine.UI.Color(.5,0,0,0));
moveWindow.Move2=Turbine.UI.Control();
moveWindow.Move2:SetParent(moveWindow.MovePanel);
moveWindow.Move2:SetSize(156,12);
moveWindow.Move2:SetPosition(17,2);
moveWindow.Move2:SetBackground(resourcePath.."move2.tga");
moveWindow.Move2:SetMouseVisible(false);
moveWindow.Move=Turbine.UI.Control();
moveWindow.Move:SetParent(moveWindow.MovePanel);
moveWindow.Move:SetSize(19,19);
moveWindow.Move:SetBackground(resourcePath.."move.tga");
moveWindow.Move:SetMouseVisible(false);
moveWindow.MoveText=Turbine.UI.Label();
moveWindow.MoveText:SetParent(moveWindow.MovePanel);
moveWindow.MoveText:SetSize(initWidth-17,12);
moveWindow.MoveText:SetPosition(17,2);
moveWindow.MoveText:SetFont(Turbine.UI.Lotro.Font.Verdana10);

moveWindow.MoveText:SetText(Resource[language][2]);
moveWindow.MovePanel:SetVisible(true);
moveWindow.MoveText:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
moveWindow.MoveText:SetMouseVisible(false);
moveWindow.MoveX=-1;
moveWindow.MoveY=0;

moveWindow.MovePanel.MouseDown=function()
end

moveWindow.MovePanel.MouseDown=function(sender,args)
	moveWindow.MoveX=args.X;
	moveWindow.MoveY=args.Y;
end
moveWindow.MovePanel.MouseUp=function(sender,args)
	moveWindow.MoveX=-1;
	moveWindow.MoveY=0;
end

moveWindow.MovePanel.MouseMove=function(sender,args)
	if moveWindow.MoveX~=-1 and (args.X~=moveWindow.MoveX or args.Y~= moveWindow.MoveY) then
		local newLeft=moveWindow:GetLeft()-(moveWindow.MoveX-args.X)
		local newTop=moveWindow:GetTop()-(moveWindow.MoveY-args.Y)
		if newLeft<0 then newLeft=0 end;
		if newLeft>(Turbine.UI.Display.GetWidth()-moveWindow:GetWidth()) then newLeft=Turbine.UI.Display.GetWidth()-moveWindow:GetWidth() end;
		if newTop<-19 then newTop=-19 end;
		if newTop>(Turbine.UI.Display.GetHeight()-moveWindow:GetHeight()) then newTop=Turbine.UI.Display.GetHeight()-moveWindow:GetHeight() end;
		mainWindow:SetPosition(newLeft,newTop+19)
		moveWindow:SetPosition(newLeft,newTop);
	end
end

mainWindow = Turbine.UI.Window();
mainWindow.MoveX=-1;
mainWindow.MoveY=-1;
mainWindow:SetSize(initWidth,initHeight);
mainWindow:SetPosition( initLeft, initTop );
mainWindow:SetVisible(true);
mainWindow:SetOpacity(Settings.Opacity);
mainWindow:SetZOrder(1)

compassWindow=Turbine.UI.Window()
compassWindow:SetSize(compassHeight,compassHeight)
compassWindow:SetPosition(initLeft,initTop-compassHeight)
compassWindow:SetVisible(false)
compassWindow:SetMouseVisible(false)
compassWindow:SetZOrder(mainWindow:GetZOrder()+1)

needleWindow=Turbine.UI.Window();
needleWindow:SetSize(compassHeight,compassHeight);
needleWindow:SetPosition(initLeft,initTop-compassHeight)
needleWindow:SetVisible(false);
needleWindow:SetMouseVisible(false)
needleWindow:SetZOrder(mainWindow:GetZOrder()+2)

mainWindow.fontMetric=FontMetric()
mainWindow.CompassQS=Turbine.UI.Lotro.Quickslot()
mainWindow.CompassQS:SetParent(mainWindow)
mainWindow.CompassQS:SetSize(mainWindow:GetWidth(),mainWindow:GetHeight())
mainWindow.CompassQS:SetPosition(0,0)
mainWindow.CompassQS:SetAllowDrop(false);

mainWindow.Heading=Turbine.UI.Label();
mainWindow.Heading:SetParent(mainWindow)
mainWindow.Heading:SetSize(mainWindow:GetWidth(),mainWindow:GetHeight())
mainWindow.Heading:SetPosition(0,0)
mainWindow.Heading:SetMultiline(false)
mainWindow.Heading:SetForeColor(Settings.FontColor)
mainWindow.Heading:SetBackColor(Turbine.UI.Color.Black)
mainWindow.Heading:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
mainWindow.Heading:SetFont(Settings.FontFace)
mainWindow.Heading:SetText("Refresh")
mainWindow.Heading:SetMouseVisible(false)

compassWindow:SetBackground(resourcePath.."compass.tga")
compassWindow:SetRotation({x=0,y=0,z=0-heading})
needleWindow:SetBackground(resourcePath.."needle.tga")
needleWindow:SetRotation({x=0,y=0,z=0-(heading)})

compassCmd="/loc"

if locale==Turbine.Language.French then
	compassCmd="/emp"
elseif locale==Turbine.Language.German then
	compassCmd="/pos"
end
mainWindow.CompassQS:SetShortcut(Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Alias, compassCmd));

mainWindow.CompassQS.DragDrop=function()
	-- reestablish the shortcut if the user accidentally drags it onto itself which wipes it out
	mainWindow.CompassQS:SetShortcut(Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Alias, compassCmd));
end
mainWindow.CompassQS:SetUseOnRightClick(false)
mainWindow.CompassQS.MouseClick=function(sender,args)
	-- pop up options on right click
	if args.Button==2 then
		popupMenu:ShowMenuAt(Turbine.UI.Display:GetMouseX(),Turbine.UI.Display:GetMouseY()+20);
	end
end
Settings.Animated=nil
-- right click menu
popupMenu=Turbine.UI.ContextMenu()
local menuList=popupMenu:GetItems();
menuList:Clear();
menuList:Add(Turbine.UI.MenuItem("Options"))
menuList:Get(1).Click=function(sender,args)
	optionsWindow:SetVisible(true)
end
local newItem=Turbine.UI.MenuItem("Animated")
newItem:SetChecked(Settings.Animate)
newItem.Click=function(sender,args)
	Settings.Animate=not Settings.Animate
	sender:SetChecked(Settings.Animate)
end
menuList:Add(newItem)

if locale==Turbine.Language.French then
	locationString="Votre emplacement .*: r.*"
	headingString="Votre emplacement .*: r.* h.*"
	patternString1="Votre emplacement est.*: r(%d+) lx(%d+%.?%d*) ly(%d+%.?%d*) ox(.-%d+%.?%d*) oy(.-%d+%.?%d*) oz(.-%d+%.?%d*)"
	patternString2="Votre emplacement est.*: r(%d+) lx(%d+%.?%d*) ly(%d+%.?%d*) cInside ox(.-%d+%.?%d*) oy(.-%d+%.?%d*) oz(.-%d+%.?%d*)"
	patternString3="Votre emplacement est.*: r(%d+) lx(%d+%.?%d*) ly(%d+%.?%d*) i(%d+) ox(%d+%.?%d*) oy(%d+%.?%d*) oz(%d+%.?%d*)"
	patternString4="Votre emplacement est.*: r(%d+) lx(%d+%.?%d*) ly(%d+%.?%d*) i(%d+) cInside ox(.-%d+%.?%d*) oy(.-%d+%.?%d*) oz(.-%d+%.?%d*)"
elseif locale==Turbine.Language.German then
	locationString="Ihr befindet Euch hier: r.*"
	headingString="Ihr befindet Euch hier: r.* h.*"
	patternString1="Ihr befindet Euch hier: r(%d+) lx(%d+%.?%d*) ly(%d+%.?%d*) ox(.-%d+%.?%d*) oy(.-%d+%.?%d*) oz(.-%d+%.?%d*)"
	patternString2="Ihr befindet Euch hier: r(%d+) lx(%d+%.?%d*) ly(%d+%.?%d*) cInside ox(.-%d+%.?%d*) oy(.-%d+%.?%d*) oz(.-%d+%.?%d*)"
	patternString3="Ihr befindet Euch hier: r(%d+) lx(%d+%.?%d*) ly(%d+%.?%d*) i(%d+) ox(%d+%.?%d*) oy(%d+%.?%d*) oz(%d+%.?%d*)"
	patternString4="Ihr befindet Euch hier: r(%d+) lx(%d+%.?%d*) ly(%d+%.?%d*) i(%d+) cInside ox(.-%d+%.?%d*) oy(.-%d+%.?%d*) oz(.-%d+%.?%d*)"
else
	-- russian is not currently supported by this plugin
	locationString="You are at: r.*"
	headingString="You are at: r.* h.*"
	patternString1="You are at: r(%d+) lx(%d+%.?%d*) ly(%d+%.?%d*) ox(.-%d+%.?%d*) oy(.-%d+%.?%d*) oz(.-%d+%.?%d*)"
	patternString2="You are at: r(%d+) lx(%d+%.?%d*) ly(%d+%.?%d*) cInside ox(.-%d+%.?%d*) oy(.-%d+%.?%d*) oz(.-%d+%.?%d*)"
	patternString3="You are at: r(%d+) lx(%d+%.?%d*) ly(%d+%.?%d*) i(%d+) ox(%d+%.?%d*) oy(%d+%.?%d*) oz(%d+%.?%d*)"
	patternString4="You are at: r(%d+) lx(%d+%.?%d*) ly(%d+%.?%d*) i(%d+) cInside ox(.-%d+%.?%d*) oy(.-%d+%.?%d*) oz(.-%d+%.?%d*)"
end
mainWindow.chatListener=function(sender, args)
	-- check message for standard channel matching "You are at: r.* lx.* ly.* ox.* oy.* oz.* h.*"
	if args.ChatType==Turbine.ChatType.Standard and string.find(args.Message,locationString)~=nil then
		local region, lx, ly, ox, oy, oz;
		if string.find(args.Message,headingString)==nil then
			-- there is a carriage return at the end of the message :(
			heading=0;
			region, lx, ly, ox, oy, oz = string.match(args.Message,patternString1);
			if region==nil then
				--You are at: r1 lx1984 ly1536 cInside ox105.19 oy-11.28 oz-56.47 h129.4
				region, lx, ly, ox, oy, oz, heading = string.match(args.Message,patternString2);
				if region==nil then
					region, lx, ly, i, ox, oy, oz, heading = string.match(args.Message,patternString3);
					if region==nil then
						region, lx, ly, i, ox, oy, oz, heading = string.match(args.Message,patternString4);
					end
				end
			end
		else
			region, lx, ly, ox, oy, oz, heading = string.match(args.Message,patternString1.." h(%d+%.?%d*)");
			if region==nil then
				--You are at: r1 lx1984 ly1536 cInside ox105.19 oy-11.28 oz-56.47 h129.4
				region, lx, ly, ox, oy, oz, heading = string.match(args.Message,patternString2.." h(%d+%.?%d*)");
				if region==nil then
					region, lx, ly, i, ox, oy, oz, heading = string.match(args.Message,patternString3.." h(%d+%.?%d*)");
					if region==nil then
						region, lx, ly, i, ox, oy, oz, heading = string.match(args.Message,patternString4.." h(%d+%.?%d*).*");
					end
				end
			end
		end
		if region ~= nil then
			if heading ==nil then
				-- when facing north the heading value is not present
				heading=0
			end
			heading=euroNormalize(heading);
			mainWindow.Heading:SetText(tostring(heading).."\194\176")
			if Settings.Animate==true then
				nextAnimatingTime=0
				animatingState=1
				mainWindow:SetWantsUpdates(true)
			end
		end
	end
end

AddCallback(Turbine.Chat, "Received", mainWindow.chatListener);

--mainWindow:SetText(Resource[language][2]);
-- no title

mainWindow.KeyDown=function(sender, args)
	if ( args.Action == Turbine.UI.Lotro.Action.Escape ) then
-- only hide on F12
--		mainWindow:SetVisible(false);
	end
	if ( args.Action == 268435579 ) then -- reposition UI
		movingToggle=not movingToggle
		-- turn off the quick slot and display the movement tag
		moveWindow:SetVisible(movingToggle)
	end
	if ( args.Action == 268435635 ) then -- toggle HUD
		hudVisible=not hudVisible;
		if hudVisible then
			mainWindow:SetVisible(mainVisible);
		else
			mainVisible=mainWindow:IsVisible();
			mainWindow:SetVisible(false);
		end
	end
end

mainWindow.MouseClick=function(sender,args)
	if args.Button==2 then
		-- user right clicked on main window
	end
end

mainWindow:SetWantsKeyEvents(true);
mainWindow:SetWantsUpdates(true)

mainWindow.RemoveShellCommands=function(sender,args)
	Turbine.Shell.RemoveCommand(mainWindow.shellCmd)
end

mainWindow.shellCmd=Turbine.ShellCommand();
local numberOfCommandsRegistered = Turbine.Shell.AddCommand(pluginName,mainWindow.shellCmd);

mainWindow.shellCmd.Execute = function(sender, cmd, args)
	if (string.lower(cmd) == string.lower(pluginName)) then
		local pos1=string.find(args," ",0,true);
		local command;
		if pos1~=nil and pos1>0 then
			command=string.lower(string.sub(args,1,pos1-1));
		else
			command=string.lower(args);
		end
		if (command=="show") then
			mainWindow:SetVisible(true);
		elseif (command=="hide") then
			mainWindow:SetVisible(false);
		elseif (command=="toggle") then
			mainWindow:SetVisible(not mainWindow:IsVisible());
		elseif (command=="debug" or command=="debug on") then
			Settings.Debug=true
			debugWindow:SetVisible(Settings.Debug)
		elseif (command=="debug off") then
			Settings.Debug=false
			debugWindow:SetVisible(Settings.Debug)
		else
			Turbine.Shell.WriteLine("usage:");
			Turbine.Shell.WriteLine("  /"..pluginName.." show");
			Turbine.Shell.WriteLine("       Displays "..pluginName..".");
			Turbine.Shell.WriteLine("  /"..pluginName.." hide");
			Turbine.Shell.WriteLine("       Hides "..pluginName..".");
			Turbine.Shell.WriteLine("  /"..pluginName.." toggle");
			Turbine.Shell.WriteLine("       Toggles "..pluginName.." (shows it if it was hidden, hides it if it was showing).");
		end
	end
end
mainWindow.shellCmd.GetHelp = function(sender, cmd)
	return("usage:\n  /"..pluginName.." show\n       Displays "..pluginName..".\n  /"..pluginName.." hide\n       Hides "..pluginName..".\n  /"..pluginName.." toggle\n       Toggles "..pluginName.." (shows it if it was hidden, hides it if it was showing).");
end
mainWindow.shellCmd.GetShortHelp = function(sender, cmd)
	return(pluginName.." - usage: /"..pluginName.." show | hide | toggle");
end
mainWindow.SetTrimColor=function()
end
mainWindow.SetBackColor=function()
	mainWindow.Heading:SetBackColor(Settings.BackColor)
end
mainWindow.SetFontColor=function()
	mainWindow.Heading:SetColor(Settings.FontColor)
end
mainWindow.SetLanguage=function()
	if mapStrings[language]==nil or type(mapStrings[language])~="table" then
		mapStrings[language]={};
	end
	mainWindow:SetText(Resource[language][2]);
end

function UnloadPlugin()
	SaveData();
	if mainWindow~=nil and mainWindow.chatListener~=nil then
		RemoveCallback(Turbine.Chat, "Received", mainWindow.chatListener);
	end

	-- have to remove all shell commands before unloading or we get a crash to desktop :(
	mainWindow:RemoveShellCommands();
--	mainWindow.MouseClick=nil;
end

function SaveData()

	Settings.Top=mainWindow:GetTop()/displayHeight
	Settings.Left=mainWindow:GetLeft()/displayWidth
	Settings.Width=mainWindow:GetWidth()/displayWidth
	Settings.Height=mainWindow:GetHeight()/displayHeight
	Settings.Opacity=mainWindow:GetOpacity()

	PatchDataSave( Turbine.DataScope.Character, pluginName.."Settings", Settings);
end

function mainWindow:Update( sender, args )
	if (Plugins[pluginName] ~= nil) and (not mainWindow.Loaded) then
		if not mainWindow.Refreshing then
			Turbine.Shell.WriteLine(pluginName.." "..Plugins[pluginName]:GetVersion()..Resource[language][3]);
		end
		Plugins[pluginName].Unload = function(mainWindow,sender,args)
			UnloadPlugin();
		end
		mainWindow.Loaded=true;
		mainWindow.fontMetric:SetFont(Settings.FontFace)
		local newWidth=mainWindow.fontMetric:GetTextWidth("Refresh")
		mainWindow:SetWidth(newWidth)
		mainWindow.Heading:SetWidth(newWidth)
		mainWindow.CompassQS:SetWidth(newWidth)
		moveWindow:SetWidth(newWidth)
		moveWindow.MoveText:SetWidth(newWidth-17)
		mainWindow:SetWantsUpdates(false);		
	elseif mainWindow.Loaded==true then
		if animatingState==0 then
		elseif animatingState==1 then
			compassWindow:SetVisible(true)
			needleWindow:SetVisible(true)
			-- rotating compass up
			if Turbine.Engine.GetGameTime()>nextAnimatingTime then
				nextAnimatingTime=Turbine.Engine.GetGameTime()+animatingInterval
				local rotation=9*(10-animatingStep)
				local topOffset=compassHeight/(10-animatingStep)
				animatingStep=animatingStep+1
				if animatingStep>10 then
					-- we're done with this stage, set up for the next stage
					animatingStep=0
					animatingState=2
				else
					compassWindow:SetTop(mainWindow:GetTop()-topOffset)
					compassWindow:SetHeight(topOffset)
					needleWindow:SetTop(mainWindow:GetTop()-topOffset)
					needleWindow:SetHeight(topOffset)
-- *** for some reason, there's a bug in DX9 where x rotation causes the image to get masked and the bottom half cut off
					compassWindow:SetRotation({x=rotation,y=0,z=0-heading})
					needleWindow:SetRotation({x=rotation,y=0,z=0-heading})
				end
			end
		elseif animatingState==2 then
			-- refreshing compass needle
			if Turbine.Engine.GetGameTime()>nextAnimatingTime then
				nextAnimatingTime=Turbine.Engine.GetGameTime()+animatingInterval
				local offset=6*(6-animatingStep)
				if animatingStep/2==math.floor(animatingStep/2) then offset=0-offset end
				animatingStep=animatingStep+1
				if animatingStep>6 then
					-- we're done with this stage, set up for the next stage
					animatingStep=0
					animatingState=3
					needleWindow:SetRotation({x=0,y=0,z=0-heading})
					compassWindow:SetRotation({x=0,y=0,z=0})
				else
					needleWindow:SetRotation({x=0,y=0,z=0-heading-offset})
					compassWindow:SetRotation({x=0,y=0,z=offset/2})
				end
			end
		elseif animatingState==3 then
			-- waiting to put compass away
			if Turbine.Engine.GetGameTime()>nextAnimatingTime then
				nextAnimatingTime=Turbine.Engine.GetGameTime()+animatingInterval
				animatingStep=animatingStep+1
				if animatingStep>15 then
					-- we're done with this stage, set up for the next stage
					animatingStep=0
					animatingState=4
				end
			end
		elseif animatingState==4 then
			-- rotating compass down
			if Turbine.Engine.GetGameTime()>nextAnimatingTime then
				nextAnimatingTime=Turbine.Engine.GetGameTime()+animatingInterval
				local rotation=9*(10-animatingStep)
				local topOffset=compassHeight/animatingStep
				animatingStep=animatingStep+1
				if animatingStep>10 then
					-- we're done with this stage, set up for the next stage
					animatingStep=0
					animatingState=0
					compassWindow:SetVisible(false)
					needleWindow:SetVisible(false)
					mainWindow:SetWantsUpdates(false);
					compassWindow:SetHeight(compassHeight)
					needleWindow:SetHeight(compassHeight)
					compassWindow:SetTop(mainWindow:GetTop()-compassHeight)
					needleWindow:SetTop(mainWindow:GetTop()-compassHeight)
				else
					compassWindow:SetTop(mainWindow:GetTop()-topOffset)
					compassWindow:SetHeight(topOffset)
					needleWindow:SetTop(mainWindow:GetTop()-topOffset)
					needleWindow:SetHeight(topOffset)
					compassWindow:SetRotation({x=90-rotation,y=0,z=0})
					needleWindow:SetRotation({x=90-rotation,y=0,z=0-heading})
				end
			end
		end
	end
end

if Settings.DataVersion~=Plugins[pluginName]:GetVersion() then
	-- perform version change auto update stuff
end

debugWindow=DebugWindow();
debugWindow:SetVisible(Settings.Debug)

debugWindow:SetZOrder(mainWindow:GetZOrder());
